-- name: [CS] Mother 64 Pack
-- description: This pack features every playable character from Mother (EB Beginings), Mother 2 (Earthbound) and Mother 3, along with a few extras!(This pack is currently STILL in development. Let me know of any bugs!)\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- I plan on expanding this mod EVEN MORE in the future! stay tuned for that!

local TEXT_MOD_NAME = "The Mother 64 Pack"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end
-- All Located in "actors"
local E_MODEL_MLOPS_NESS = smlua_model_util_get_id("mlops_ness_geo")
local E_MODEL_NINTEN = smlua_model_util_get_id("ninten_geo")
local E_MODEL_KEN = smlua_model_util_get_id("ken_geo")
local E_MODEL_LUCAS = smlua_model_util_get_id("lucas_geo")
local E_MODEL_DOUG = smlua_model_util_get_id("douglas_geo")
local E_MODEL_EB64LUCAS = smlua_model_util_get_id("eb64_lucas_geo")
local E_MODEL_PIPPI = smlua_model_util_get_id("pippi_geo")
 -- All Located in "textures"
local TEX_MLOPS_NESS_LIFE_ICON = get_texture_info("mlops_ness-icon")
local TEX_NINTEN_LIFE_ICON = get_texture_info("ninten-icon")
local TEX_KEN_LIFE_ICON = get_texture_info("ken-icon")
local TEX_LUCAS_LIFE_ICON = get_texture_info("lucas-icon")
local TEX_DOUG_LIFE_ICON = get_texture_info("doug-icon")
local TEX_EB64LUCAS_LIFE_ICON = get_texture_info("lucas64-icon")
local TEX_PIPPI_LIFE_ICON = get_texture_info("pippi-icon")

--[[
 Voices to be made in the future, here, have placeholder silence for now.
-- All Located in "sound"
local VOICETABLE_MLOPS_NESS = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}

local VOICETABLE_NINTEN = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}

local VOICETABLE_LUCAS = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',

    local VOICETABLE_PIPPI = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}
]]

local VOICETABLE_PLACEHOLDER = { nil }

-- All Located in "actors"
local CAPTABLE_MLOPS_NESS = {
    normal = smlua_model_util_get_id("mlops_ness_cap_geo"),
    wing = smlua_model_util_get_id("mlops_ness_wing_cap_geo"),
    metal = smlua_model_util_get_id("mlops_ness_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mlops_ness_winged_metal_cap_geo"),
}

local CAPTABLE_LUCAS = {
    normal = smlua_model_util_get_id("lucas_cap_geo"),
    wing = smlua_model_util_get_id("lucas_wing_cap_geo"),
    metal = smlua_model_util_get_id("lucas_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("lucas_winged_metal_cap_geo"),
}

local CAPTABLE_PIPPI = {
    normal = smlua_model_util_get_id("pippis_cap_geo"),
    wing = smlua_model_util_get_id("pippis_wing_cap_geo"),
    metal = smlua_model_util_get_id("pippis_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("pippis_winged_metal_cap_geo"),
}
 -- All Located in "main.lua"
local PALETTE_MLOPS_NESS = {
    [PANTS]  = "6800F8",
    [SHIRT]  = "F8F000",
    [GLOVES] = "8840F8",
    [SHOES]  = "F80000",
    [HAIR]   = "000000",
    [SKIN]   = "F8D0A0",
    [CAP]    = "F80000",
    [EMBLEM] = "6800F8",
}

local PALETTE_NINTEN = {
    [PANTS]  = "5A698D",
    [SHIRT]  = "F9F800",
    [GLOVES] = "8888F8",
    [SHOES]  = "8888F8",
    [HAIR]   = "1F1F1F",
    [SKIN]   = "FFD6BF",
    [CAP]    = "F81071",
    [EMBLEM] = "8888F8",
}

local PALETTE_KEN = {
    [PANTS]  = "5A698D",
    [SHIRT]  = "A25044",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "8888F8",
    [HAIR]   = "F8F800",
    [SKIN]   = "FFD6BF",
    [CAP]    = "F81071",
    [EMBLEM] = "8888F8",
}

local PALETTE_LUCAS = {
    [PANTS]  = "8888F8",
    [SHIRT]  = "F8F000",
    [GLOVES] = "F81070",
    [SHOES]  = "F80000",
    [HAIR]   = "F8F8A0",
    [SKIN]   = "F8D0A0",
    [CAP]    = "FFFF00",
    [EMBLEM] = "FFFFFF",
}

local PALETTE_EB64LUCAS = {
    [PANTS]  = "888C62",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "F81070",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "E2AB2E",
    [SKIN]   = "F8D0A0",
    [CAP]    = "FFFF00",
    [EMBLEM] = "1274B7",
}

local PALETTE_DOUG = {
    [PANTS]  = "0655A0",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "3FABD1",
    [SHOES]  = "CB313B",
    [HAIR]   = "71352B",
    [SKIN]   = "E6B89E",
    [CAP]    = "CB313B",
    [EMBLEM] = "CB313B",
}

local PALETTE_PIPPI = {
    [PANTS]  = "F8A6AC",
    [SHIRT]  = "F71571",
    [GLOVES] = "FFE147",
    [SHOES]  = "F71571",
    [HAIR]   = "FD483E",
    [SKIN]   = "FED3BD",
    [CAP]    = "FFE147",
    [EMBLEM] = "FFE147",
}
 -- All Located in "textures"
local HEALTH_METER_MLOPS_NESS = {
    label = {
        left = get_texture_info("mlops_ness_pm1"),
        right = get_texture_info("mlops_ness_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
    }
}

local HEALTH_METER_NINTEN = {
    label = {
        left = get_texture_info("ninten_pm1"),
        right = get_texture_info("ninten_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),
    }
}
 -- All Located in "main.lua"
local CSloaded = false
local function on_character_select_load()
    CT_NINTEN = _G.charSelect.character_add("Ninten", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the original Mother", "Mlops, design from Mother Encore", {r = 248, g = 16, b = 113}, E_MODEL_NINTEN, CT_MARIO, TEX_NINTEN_LIFE_ICON)
    CT_PIPPI = _G.charSelect.character_add("Pippi", "This girl who lives in podunk is always getting herself into a mess! She also has a thing for eating grass, so it seems? Legend has it she's based off a famous book's character!", "Mlops, design from Mother Encore", {r = 255, g = 255, b = 71}, E_MODEL_PIPPI, CT_WARIO, TEX_PIPPI_LIFE_ICON)
    CT_MLOPS_NESS = _G.charSelect.character_add("Ness", "An average 12 year-old with psychic powers, who left his hometown, Onett, after meeting a hero from a ruined future. the first out of the chosen four from Mother 2", "Mlops", {r = 248, g = 0, b = 0}, E_MODEL_MLOPS_NESS, CT_MARIO, TEX_MLOPS_NESS_LIFE_ICON)
    CT_LUCAS = _G.charSelect.character_add("Lucas", "A timid and nervous teen, who lost his mother and brother, Claus, at a young age. Protagonist of Mother 3.", "Mlops", {r = 255, g = 255, b = 0}, E_MODEL_LUCAS, CT_MARIO, TEX_LUCAS_LIFE_ICON)

    _G.charSelect.character_add_costume(CT_NINTEN, "Ken", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the Mother Novelization", "Mlops", {r = 248, g = 16, b = 113}, E_MODEL_KEN, CT_MARIO, TEX_KEN_LIFE_ICON)
    _G.charSelect.character_add_costume(CT_NINTEN, "Douglas Halloway", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the Mother: Invasion From the Unknown Book.", "Mlops", {r = 248, g = 16, b = 113}, E_MODEL_DOUG, CT_MARIO, TEX_DOUG_LIFE_ICON)

    _G.charSelect.character_add_costume(CT_LUCAS, "Lucas", "A timid and nervous teen, who lost his mother and brother, Claus, at a young age. Protagonist of Mother 3. This variation is based off his design in EarthBound 64!", "Mlops", {r = 255, g = 255, b = 0}, E_MODEL_EB64LUCAS, CT_MARIO, TEX_EB64LUCAS_LIFE_ICON)

    _G.charSelect.character_add_caps(E_MODEL_MLOPS_NESS, CAPTABLE_MLOPS_NESS)
    _G.charSelect.character_add_caps(E_MODEL_NINTEN, CAPTABLE_MLOPS_NESS)
    _G.charSelect.character_add_caps(E_MODEL_KEN, CAPTABLE_MLOPS_NESS)
    _G.charSelect.character_add_caps(E_MODEL_LUCAS, CAPTABLE_LUCAS)
    _G.charSelect.character_add_caps(E_MODEL_DOUG, CAPTABLE_MLOPS_NESS)
    _G.charSelect.character_add_caps(E_MODEL_EB64LUCAS, CAPTABLE_LUCAS)
    _G.charSelect.character_add_caps(E_MODEL_PIPPI, CAPTABLE_PIPPI)
    _G.charSelect.character_add_voice(E_MODEL_MLOPS_NESS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_NINTEN, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_KEN, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_LUCAS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_DOUG, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_EB64LUCAS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_PIPPI, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_palette_preset(E_MODEL_MLOPS_NESS, PALETTE_MLOPS_NESS)
    _G.charSelect.character_add_palette_preset(E_MODEL_NINTEN, PALETTE_NINTEN)
    _G.charSelect.character_add_palette_preset(E_MODEL_KEN, PALETTE_KEN)
    _G.charSelect.character_add_palette_preset(E_MODEL_LUCAS, PALETTE_LUCAS)
    _G.charSelect.character_add_palette_preset(E_MODEL_DOUG, PALETTE_DOUG)
    _G.charSelect.character_add_palette_preset(E_MODEL_EB64LUCAS, PALETTE_EB64LUCAS)
    _G.charSelect.character_add_palette_preset(E_MODEL_PIPPI, PALETTE_PIPPI)
    _G.charSelect.character_add_health_meter(CT_MLOPS_NESS, HEALTH_METER_MLOPS_NESS)
    _G.charSelect.character_add_health_meter(CT_NINTEN, HEALTH_METER_NINTEN)
    _G.charSelect.character_add_costume_health_meter(CT_NINTEN, 2, HEALTH_METER_NINTEN)
    _G.charSelect.character_add_costume_health_meter(CT_NINTEN, 2, HEALTH_METER_MLOPS_NESS)
    CSloaded = true
end

_G.charSelect.credit_add(TEXT_MOD_NAME, "MlopsFunny", "Models")
_G.charSelect.credit_add(TEXT_MOD_NAME, "Mother Encore", "Designs used for M1 Cast")
_G.charSelect.credit_add(TEXT_MOD_NAME, "Melzinoff", "Template Used for HP Bars")
_G.charSelect.credit_add(TEXT_MOD_NAME, "Wibblus", "Legacy Costume Swapping Code")




local function on_character_sound(m, sound)
    if not CSloaded then return end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_MLOPS_NESS then return _G.charSelect.voice.sound(m, sound) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NINTEN then return _G.charSelect.voice.sound(m, sound) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_LUCAS then return _G.charSelect.voice.sound(m, sound) end
        --if _G.charSelect.character_get_voice(m) == VOICETABLE_PIPPI then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PLACEHOLDER then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_MLOPS_NESS then return _G.charSelect.voice.snore(m) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NINTEN then return _G.charSelect.voice.snore(m) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_LUCAS then return _G.charSelect.voice.snore(m) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_PIPPI then return _G.charSelect.voice.snore(m) end
   if _G.charSelect.character_get_voice(m) == VOICETABLE_PLACEHOLDER then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)